// { dg-do run { target c++11 } }

// Copyright (C) 2014-2021 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the terms
// of the GNU General Public License as published by the Free Software
// Foundation; either version 3, or (at your option) any later
// version.

// This library is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this library; see the file COPYING3.  If not see
// <http://www.gnu.org/licenses/>.

// C++11 [ptr.align] (20.6.5): std::align

#include <memory>
#include <testsuite_hooks.h>

void
test01()
{
  int i = 0;
  void* ptr = &i;
  auto space = sizeof(i);
  auto p2 = std::align(alignof(int), space, ptr, space);
  VERIFY( ptr == &i );
  VERIFY( p2 == &i );
  VERIFY(space == sizeof(i));
}

int main()
{
  test01();
}
