// { dg-do run }
// { dg-additional-options "-pthread" { target pthread } }
// { dg-require-effective-target c++11 }
// { dg-require-gthreads "" }

// Copyright (C) 2009-2021 Free Software Foundation, Inc.
//
// This file is part of the GNU ISO C++ Library.  This library is free
// software; you can redistribute it and/or modify it under the
// terms of the GNU General Public License as published by the
// Free Software Foundation; either version 3, or (at your option)
// any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License along
// with this library; see the file COPYING3.  If not see
// <http://www.gnu.org/licenses/>.


#include <future>
#include <testsuite_hooks.h>

int& inc(int& i) { return ++i; }

void test01()
{
  std::packaged_task<int&(int&)> p1(inc);
  std::future<int&> f1 = p1.get_future();

  std::chrono::milliseconds delay(1);
  VERIFY( f1.valid() );
  VERIFY( f1.wait_for(delay) == std::future_status::timeout );

  int i1 = 0;

  p1(i1);

  int& i2 = f1.get();

  VERIFY( &i1 == &i2 );
  VERIFY( i1 == 1 );
}

int main()
{
  test01();
  return 0;
}
